Require Import Utf8.
Require Import CpdtTactics LibTactics.

Notation "A '/' B" := (A → B)  (only parsing).
Notation "A × B" := (A * B)%type (at level 40).

Notation "f  _( x_1 )_  ⇓ y" := (f x_1 y) (at level 30, only parsing).
Notation "f  _( x_1 , x_2 )_  ⇓ y" := (f x_1 x_2 y)  (at level 30, only parsing).
Notation "f  _( x_1 , x_2 , x_3 )_  ⇓ y" := (f x_1 x_2 x_3 y)  (at level 30, only parsing).
Notation "f  _( x_1 , x_2 , x_3 , x_4 )_  ⇓ y" := (f x_1 x_2 x_3 x_4 y)  (at level 30, only parsing).
Notation "f  _( x_1 , x_2 , x_3 , x_4 , x_5 )_  ⇓ y" := (f x_1 x_2 x_3 x_4 x_5 y)  (at level 30, only parsing).
Notation "f  _( x_1 , x_2 , x_3 , x_4 , x_5 , x_6 )_  ⇓ y" := (f x_1 x_2 x_3 x_4 x_5 x_6 y)  (at level 30, only parsing).

Ltac clear_dup :=
  match goal with
    | [ H : ?X |- _ ] =>
      match goal with
        | [ H' : ?Y |- _ ] =>
          match H with
            | H' => fail 2
            | _ => unify X Y ; (clear H' || clear H)
          end
      end
  end.

Ltac clear_dups := repeat clear_dup.

Ltac gen_subst_once :=
  match goal with 
    |  H1 : ?R ?x1 ?y, H2: ?R ?x1 ?y' |- _ => 
       assert (y=y') by eauto with gen_subst_db;
         subst; clear_dups
    |  H1 : ?R ?x1 ?x2 ?y, H2: ?R ?x1 ?x2 ?y' |- _ => 
       assert (y=y') by eauto with gen_subst_db;
          subst; clear_dups
    |  H1 : ?R ?x1 ?x2 ?x3 ?y, H2: ?R ?x1 ?x2 ?x3 ?y' |- _ => 
       assert (y=y') by eauto with gen_subst_db;
         subst; clear_dups
    |  H1 : ?R ?x1 ?x2 ?x3 ?x4 ?y, H2: ?R ?x1 ?x2 ?x3 ?x4 ?y' |- _ => 
       assert (y=y') by eauto with gen_subst_db;
         subst; clear_dups
     |  H1 : ?R ?x1 ?x2 ?x3 ?x4 ?x5 ?y, H2: ?R ?x1 ?x2 ?x3 ?x4 ?x5 ?y' |- _ => 
       assert (y=y') by eauto with gen_subst_db;
          subst; clear_dups
  end.

Ltac gen_subst_pair :=
  match goal with 
    |  H : (?x1,?y1) = (?x2,?y2) |- _ => inverts H; subst
  end.

Ltac gen_subst := repeat (progress (crush || gen_subst_once || gen_subst_pair)).

Ltac destruct_once :=
  match goal with 
   | H: _ |- _ => (let x := fresh "x" in let x:= constr:(let (u) := H in u) in (inverts H || destruct H))
   | H: _ |- _ => (let x := fresh "x" in let x:= constr:(let (u,u2) := H in u) in (inverts H || destruct H))
   | H: _ |- _ => (let x := fresh "x" in let x:= constr:(let (u,u2,u3) := H in u) in (inverts H || destruct H))
   | H: _ |- _ => (let x := fresh "x" in let x:= constr:(let (u,u2,u3,u4) := H in u) in (inverts H || destruct H))
   | H: _ |- _ => (let x := fresh "x" in let x:= constr:(let (u,u2,u3,u4,u5) := H in u) in (inverts H || destruct H))
   | H: _ |- _ => (let x := fresh "x" in let x:= constr:(let (u,u2,u3,u4,u5,u6) := H in u) in (inverts H || destruct H))
   | H: _ |- _ => (let x := fresh "x" in let x:= constr:(let (u,u2,u3,u4,u5,u6,u7) := H in u) in (inverts H || destruct H))
   | H: _ |- _ => (let x := fresh "x" in let x:= constr:(let (u,u2,u3,u4,u5,u6,u7,u8) := H in u) in (inverts H || destruct H))
   | H: _ |- _ => (let x := fresh "x" in let x:= constr:(let (u,u2,u3,u4,u5,u6,u7,u8,u9) := H in u) in (inverts H || destruct H))
   | H: _ |- _ => (let x := fresh "x" in let x:= constr:(let (u,u2,u3,u4,u5,u6,u7,u8,u9,v0) := H in u) in (inverts H || destruct H))
   | H: _ |- _ => (let x := fresh "x" in let x:= constr:(let (u,u2,u3,u4,u5,u6,u7,u8,u9,v0,v1) := H in u) in (inverts H || destruct H))
   | H: _ |- _ => (let x := fresh "x" in let x:= constr:(let (u,u2,u3,u4,u5,u6,u7,u8,u9,v0,v1,v2) := H in u) in (inverts H || destruct H))
   | H: _ |- _ => (let x := fresh "x" in let x:= constr:(let (u,u2,u3,u4,u5,u6,u7,u8,u9,v0,v1,v2,v3) := H in u) in (inverts H || destruct H))
   | H: _ |- _ => (let x := fresh "x" in let x:= constr:(let (u,u2,u3,u4,u5,u6,u7,u8,u9,v0,v1,v2,v3,v4) := H in u) in (inverts H || destruct H))
   | H: _ |- _ => (let x := fresh "x" in let x:= constr:(let (u,u2,u3,u4,u5,u6,u7,u8,u9,v0,v1,v2,v3,v4,v5) := H in u) in (inverts H || destruct H))
   | H: _ |- _ => (let x := fresh "x" in let x:= constr:(let (u,u2,u3,u4,u5,u6,u7,u8,u9,v0,v1,v2,v3,v4,v5,v6) := H in u) in (inverts H || destruct H))
   | H: _ |- _ => (let x := fresh "x" in let x:= constr:(let (u,u2,u3,u4,u5,u6,u7,u8,u9,v0,v1,v2,v3,v4,v5,v6,v7) := H in u) in (inverts H || destruct H))
   | H: _ |- _ => (let x := fresh "x" in let x:= constr:(let (u,u2,u3,u4,u5,u6,u7,u8,u9,v0,v1,v2,v3,v4,v5,v6,v7,v8) := H in u) in (inverts H || destruct H))
   | H: _ |- _ => (let x := fresh "x" in let x:= constr:(let (u,u2,u3,u4,u5,u6,u7,u8,u9,v0,v1,v2,v3,v4,v5,v6,v7,v8,v9) := H in u) in (inverts H || destruct H))
  end.

Ltac destruct_all := repeat (progress (crush || destruct_once)).

Tactic Notation "destruct" "all" := destruct_all.

Ltac revert_last :=
  match goal with
    [ H : _ |- _ ] => revert H
  end.

Ltac clear_last :=
  match goal with
    [ H : _ |- _ ] => clear H
  end.

Tactic Notation "eapply" "keep" tactic(I) "in" hyp(H) :=
  let H' := fresh H in (assert (H' := H); eapply I in H').

Tactic Notation "eapply" "keep" tactic(I) "in" hyp(H) "as" ident(H2) :=
  let H2 := fresh H2 in (assert (H2 := H); eapply I in H2).

Notation "'unique_spec_1' p" := 
  (fun x1 y h => ∀ y', (p x1 y') → y = y') (at level 30).
Notation "'unique_spec_2' p" :=
  (fun x1 x2 y h  => ∀ y', (p x1 x2 y') → y = y') (at level 30).
Notation "'unique_spec_3' p" :=
  (fun x1 x2 x3 y h  => ∀ y', (p x1 x2 x3 y') → y = y') (at level 30).
Notation "'unique_spec_4' p" :=
  (fun x1 x2 x3 x4 y h  => ∀ y', (p x1 x2 x3 x4 y') → y = y') (at level 30).

Tactic Notation "simple_unique_tac" :=
  introv; revert_last;
  intros y1 H H0; revert H0; revert y1;
  induction H; 
    (intros y2 D2; inversion D2; destruct_all; repeat progress ( eauto || econstructor || gen_subst || crush )).

Ltac unique_tac L :=
    repeat clear_last;
    introv; revert_last;
    intros y1 H H0; revert H0; revert y1;
    apply L;
    (intros; revert_last; intro D2; inversion D2;
     repeat progress ( eauto || econstructor || gen_subst || crush )).

(* A backtracking version of "econstructor" *)
Ltac econstructors_tac tac :=
 match goal with
   | _ => tac
   | _ => now(econstructor 1; econstructors_tac tac)
   | _ => now(econstructor 2; econstructors_tac tac)
   | _ => now(econstructor 3; econstructors_tac tac)
   | _ => now(econstructor 4; econstructors_tac tac)
   | _ => now(econstructor 5; econstructors_tac tac)
   | _ => now(econstructor 6; econstructors_tac tac)
   | _ => now(econstructor 7; econstructors_tac tac)
   | _ => now(econstructor 8; econstructors_tac tac)
   | _ => now(econstructor 9; econstructors_tac tac)
 end.

Tactic Notation "econstructors" tactic(tac) := econstructors_tac tac.

(* Export tactics notations from LibTactics *)
Tactic Notation "inverts" hyp(H) "as" simple_intropattern(I1) :=
  invert_tactic H (fun H => inverts keep H as I1).
Tactic Notation "inverts" hyp(H) "as" simple_intropattern(I1) 
 simple_intropattern(I2) :=
  invert_tactic H (fun H => inverts keep H as I1 I2).
Tactic Notation "inverts" hyp(H) "as" simple_intropattern(I1) 
 simple_intropattern(I2) simple_intropattern(I3) :=
  invert_tactic H (fun H => inverts keep H as I1 I2 I3).
Tactic Notation "inverts" hyp(H) "as" simple_intropattern(I1) 
 simple_intropattern(I2) simple_intropattern(I3) simple_intropattern(I4) :=
  invert_tactic H (fun H => inverts keep H as I1 I2 I3 I4).
Tactic Notation "inverts" hyp(H) "as" simple_intropattern(I1) 
 simple_intropattern(I2) simple_intropattern(I3) simple_intropattern(I4) 
 simple_intropattern(I5) :=
  invert_tactic H (fun H => inverts keep H as I1 I2 I3 I4 I5).
Tactic Notation "inverts" hyp(H) "as" simple_intropattern(I1) 
 simple_intropattern(I2) simple_intropattern(I3) simple_intropattern(I4) 
 simple_intropattern(I5) simple_intropattern(I6) :=
  invert_tactic H (fun H => inverts keep H as I1 I2 I3 I4 I5 I6).

(* For coq 8.5 *)
Tactic Notation "auto" := eauto.
Tactic Notation "split" := constructor.
